; Many thanks to Raymond for his image library RFimageLib.lib

include		imglibtest.inc
include		fish.inc

.data
ClassName   db "RFimageLibClass",0
AppName     db "GIF image",0

.data?
hInstance   HINSTANCE ?
hTempDC		dd ?
oldbm		dd ?
hGIF		dd ?
hDC			dd ?

.code

start:

    invoke  GetModuleHandle, NULL
    mov     hInstance,eax
    invoke  GetCommandLine
    invoke  WinMain,hInstance,NULL,eax,SW_SHOWDEFAULT
    invoke  ExitProcess,eax

WinMain  PROC hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD

 LOCAL wc:WNDCLASSEX
 LOCAL msg:MSG
 LOCAL hwnd:HWND

	mov		wc.cbSize,SIZEOF WNDCLASSEX
	mov		wc.style, CS_HREDRAW or CS_VREDRAW
	mov		wc.lpfnWndProc, OFFSET WndProc
	mov		wc.cbClsExtra,NULL
	mov		wc.cbWndExtra,NULL
	push	hInstance
	pop		wc.hInstance
	mov		wc.hbrBackground,COLOR_WINDOW+1
	mov		wc.lpszMenuName,NULL
	mov		wc.lpszClassName,OFFSET ClassName
	invoke  LoadIcon,NULL,IDI_APPLICATION
	mov		wc.hIcon,eax
	mov		wc.hIconSm,eax
	invoke	LoadCursor,NULL,IDC_ARROW
	mov		wc.hCursor,eax
	invoke	RegisterClassEx, ADDR wc
	invoke	CreateWindowEx,NULL,ADDR ClassName,ADDR AppName,\
			WS_OVERLAPPEDWINDOW,200,200,\
			200,135,NULL,NULL,\
			hInst,NULL
	mov		hwnd,eax

	invoke	GetDC,eax
	mov		hDC,eax
	invoke	memGIF,ADDR pImage,ln_pImage,eax
	mov		hGIF,eax
	invoke	CreateCompatibleDC,hDC
	mov		hTempDC,eax
	mov		eax,hGIF
	mov		eax,[eax].DIBINFO.hDIB
	invoke	SelectObject,hTempDC,eax
	mov		oldbm,eax

	invoke  ShowWindow,hwnd,SW_SHOWNORMAL
	invoke  UpdateWindow,hwnd

.WHILE TRUE
	invoke  GetMessage, ADDR msg,NULL,0,0
	.BREAK  .if (!eax)
	invoke  TranslateMessage, ADDR msg
	invoke  DispatchMessage, ADDR msg
.ENDW

	mov	 eax,msg.wParam
	ret

WinMain ENDP

WndProc PROC hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

LOCAL ps:PAINTSTRUCT
				  
	.IF uMsg==WM_PAINT
		
		invoke  BeginPaint,hWnd,ADDR ps
		mov		eax,hGIF
		mov		ecx,[eax].DIBINFO.bmih.bmiHeader.biWidth
		mov		edx,[eax].DIBINFO.bmih.bmiHeader.biHeight
		test	edx,edx
		jns		@F
		neg		edx
@@:
		invoke	BitBlt,hDC,0,0,ecx,edx,hTempDC,0,0,SRCCOPY
		invoke  EndPaint,hWnd,ADDR ps

	.ELSEIF uMsg==WM_DESTROY

		invoke 	SelectObject,hTempDC,oldbm
		mov		eax,hGIF
		mov 	eax,[eax].DIBINFO.hDIB
		invoke	DeleteObject,eax
		invoke	DeleteDC,hTempDC
		invoke  PostQuitMessage,NULL

	.ELSE

		invoke  DefWindowProc,hWnd,uMsg,wParam,lParam  
		ret

	.ENDIF

	xor	eax,eax
	ret

WndProc ENDP
END start
